<?php
lt_include(PLOG_CLASS_PATH."class/view/plugintemplatedview.class.php");
lt_include(PLOG_CLASS_PATH."plugins/gallery/class/gallery/galleryhelper.class.php");

class PluginGalleryShowView extends PluginTemplatedView
{
    function PluginGalleryShowView($blogInfo)
    {
        $this->PluginTemplatedView($blogInfo,
                                    "gallery",
                                    "galleryShow",
                                    SMARTY_VIEW_CACHE_DISABLED);
    }

    function render()
    {
        // Get the current gallery settings
        $blogSettings = $this->_blogInfo->getSettings();
        $pluginEnabled = $blogSettings->getValue("plugin_gallery_enabled");
        $sidebarEnabled = $blogSettings->getValue("gallery_sidebar_enabled");
        $sidebarGreetingEnabled = $blogSettings->getValue("gallery_sidebarGreeting_enabled");
        $pathbarEnabled = $blogSettings->getValue("gallery_pathbar_enabled");
        $absolutePath = $blogSettings->getValue("gallery_absolute_path");
        $embedUri = $blogSettings->getValue("gallery_embed_uri");
        $embedPath = $blogSettings->getValue("gallery_embed_path");
        $relativePath = $blogSettings->getValue("gallery_relative_path");

        $embedMode = $blogSettings->getValue("gallery_embedMode");
        $galleryUrl = $blogSettings->getValue("gallery_galleryUrl");
        if (!$embedMode) {
		$args = '';
		foreach ($_GET as $key => $val) {
			if ($key == 'op') continue;
			if (is_array($val)) {
				$s = '';
				foreach ($val as $k => $v) {
					if (is_array($v)) continue;
					if ($s === '') 
						$s = $key.'['.$k.']='.urlencode($v);
					else
						$s .= '&'.$key.'['.$k.']='.urlencode($v);
				}	
				if ($s === '') continue;
			}
			else
				$s = $key.'='.urlencode($val);
			if ($args === '')
				$args = '?'.$s;
			else
				$args .= '&'.$s;
		}
		// just redirect it if not allow embed
		header("Location: ".$galleryUrl.$args);
		die();
	}

        // Create a gallery helper object to interact with gallery
        $gallery = new GalleryHelper($absolutePath,
				      $embedUri,
				      $embedPath,
				      $relativePath);

        $gallery->getGallery($sidebarEnabled,
                     $sidebarGreetingEnabled,
                     $pathbarEnabled);

        // Export values to the template
        $this->setValue("pluginEnabled", $pluginEnabled);
        $this->setValue("galleryTitle", $gallery->getTitle());
        $this->setValue("galleryCSS", $gallery->getCSS());
        $this->setValue("galleryJavascript", $gallery->getJavascript());
        $this->setValue("galleryBody", $gallery->getBody());
        $this->setValue("galleryError", $gallery->getError());

        parent::render();

        return true;
    }
}
?>
