<?php
lt_include(PLOG_CLASS_PATH."class/plugin/pluginbase.class.php");
lt_include(PLOG_CLASS_PATH."plugins/gallery/class/gallery/galleryhelper.class.php");

class PluginGallery extends PluginBase
{
    var $_pluginEnabled;

    function Plugingallery($source = "")
    {
        $this->PluginBase($source);

        $this->id = "gallery";
        $this->author = "twu2";
        $this->desc = "Integrates gallery2 into LifeType.";
        $this->version = "20111210";

        $this->locales = Array("en_UK");

        if ($source == "admin")
            $this->initAdmin();
        else
            $this->init();
    }

    function init()
    {
        $this->registerBlogAction("gallery", "PluginGalleryShowAction");
    }

    function initAdmin()
    {
        // Register the actions
        $this->registerBlogAction("gallery", "PluginGalleryShowAction");
        $this->registerAdminAction("gallery", "PluginGalleryConfigAction");
        $this->registerAdminAction("updateGalleryConfig", "PluginGalleryUpdateConfigAction");

        // Set up the Admin menu options
        $menu =& Menu::getMenu();
        if(!$menu->entryExists("/menu/controlCenter/embeddedApps")) {
            $this->addMenuEntry("/menu/controlCenter", "embeddedApps", "", "", true, false);
        }
        $this->addMenuEntry("/menu/controlCenter/embeddedApps", "Gallery", "?op=gallery", "");
    }

    function register()
    {
        $blogSettings = $this->blogInfo->getSettings();
        $this->_pluginEnabled = $blogSettings->getValue("plugin_gallery_enabled");

        return true;
    }

    function getImageBlock()
    {
	if (preg_match("/spider/i", $_SERVER['HTTP_USER_AGENT']) > 0)
	    return "";
        // Get the necessary blog settings
        $blogSettings = $this->blogInfo->getSettings();
        $embedMode = $blogSettings->getValue("gallery_embedMode");
        $galleryUrl = $blogSettings->getValue("gallery_galleryUrl");
        $absolutePath = $blogSettings->getValue("gallery_absolute_path");
        $embedUri = $blogSettings->getValue("gallery_embed_uri");
        $embedPath = $blogSettings->getValue("gallery_embed_path");
        $relativePath = $blogSettings->getValue("gallery_relative_path");
        $blocks = $blogSettings->getValue("gallery_blocks");
        $show = $blogSettings->getValue("gallery_show");
        $itemid = $blogSettings->getValue("gallery_itemid");

        // Create a gallery helper object to interact with gallery
        $gallery = new GalleryHelper($absolutePath, $embedUri, $embedPath, $relativePath);

        if ($blocks == "")
            $blocks = "randomImage";
        if ($show == "")
            $show = "none";

        // Get the image block
        return $gallery->getImageBlock($blocks, $show, $itemid, $embedMode, $galleryUrl);
    }

    function isEnabled()
    {
        return $this->_pluginEnabled;
    }

    function getGalleryUrl($blogLink)
    {
        $blogSettings = $this->blogInfo->getSettings();
        $embedMode = $blogSettings->getValue("gallery_embedMode");
        $galleryUrl = $blogSettings->getValue("gallery_galleryUrl");
        if ($embedMode)
            return "$blogLink/index.php?op=gallery";
        return $galleryUrl;
    }
}
?>
